/*  Floating Point(Double) Calc Subroutine
        void d_neg(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _zrchkd(unsigned char *);

/*      x = -x;     */
void d_neg(unsigned char *x)
{
    if (_zrchkd(x) == 0) {

#if     FLTMPU
        if (x[0] & 0x80) x[0] &= 0x7f;
        else x[0] |= 0x80;
#else
        if (x[7] & 0x80) x[7] &= 0x7f;
        else x[7] |= 0x80;
#endif
    }
}
