/*  Floating Point(Float) Calc Subroutine
        void f_pai(unsigned char *x,int n);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */

void f_pai(unsigned char *x,int n)
{ unsigned long     *ux;

    ux = (unsigned long *)x;
    switch(n) {
        case    0:      /* pai */
            *ux = 0x40490fdb;
            break;
        case    1:      /* pai*2 */
            *ux = 0x40c90fdb;
            break;
        case    2:      /* pai/2 */
            *ux = 0x3fc90fdb;
            break;
        case    3:      /* pai*3/2 */
            *ux = 0x4096cbe4;
            break;
        case    4:      /* pai/4 */
            *ux = 0x3f490fdb;
            break;
        case    5:      /* 180/pai */
            *ux = 0x42652ee0;
            break;
    }
}
