/*  Floating Point(Double) Calc Subroutine
        void a_tod(char *c,unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _numchk(char);
int     _zrchkd(unsigned char *);
void    _ovrfld(unsigned char *,int);
void    _undfld(unsigned char *);

void    _dadd1b(unsigned char *,int);
void    _mlt10d(unsigned char *);
void    _dnorm2(unsigned char *,int,short *);
void    d_mov(unsigned char *,unsigned char *);

void a_tod(char *c,unsigned char *x)
{ int   i,exps,expe,sgn;
  short *expx;
  unsigned short    *us;
  unsigned char     fx[10];
  unsigned long     *ux;

    expx = (short *)(fx+8);
    sgn = 0;
    expe = 0;
    exps = 0;
    for (i=0;i<10;i++) fx[i] = 0;
    *expx = 0x437;

    i = 0;
    while(1) {
        if (_numchk(c[i])) {
#if     FLTMPU
            if (fx[0] == 0) {
#else
            if (fx[7] == 0) {
#endif
                _mlt10d(fx);
                _dadd1b(fx,c[i] & 0xf);
                if (sgn & 0x2) exps--;
            }
            else {
                if ((sgn & 0x2) == 0) exps++;
            }
        }
        else if (c[i] == '.') {
            sgn |= 0x2;
        }
        else if (c[i] == '-') {
            sgn |= 0x1;
        }
        else if ((c[i] == 'e') || (c[i] == 'E') || (c[i] == 0)) {
            break;
        }
        i++;
    }

    if (_zrchkd(fx)) {
        ux = (unsigned long *)x;
        *ux = 0;
        *(ux+1) = 0;
        return;
    }

    if (c[i]) {
        i++;
        while(1) {
            if (_numchk(c[i])) {
                expe *= 10;
                expe += (c[i] & 0xf);
            }
            else if (c[i] == '-') {
                sgn |= 0x4;
            }
            else if (c[i] == 0) break;
            i++;
        }
        if (sgn & 0x4) expe = -expe;
    }

    exps += expe;

    _dnorm2(fx,exps,expx);

    if (*expx < 0) _undfld(fx);
    else if (*expx > 0x7ff) _ovrfld(fx,sgn & 0x1);
    else {
#if     FLTMPU
        us = (unsigned short *)fx;
#else
        us = (unsigned short *)(fx+6);
#endif
        *expx <<= 4;
#if     FLTMPU
        i = fx[1] & 0xf;
#else
        i = fx[6] & 0xf;
#endif
        *us = i | *expx;
        if (sgn & 0x1) *us |= 0x8000;
    }
    d_mov(x,fx);
}

