/*  Floating Point(Double) Calc Subroutine
        void d_asn(unsigned char *x);
            asin(x) = atan((x/sqr(1-x*x));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    d_sub(unsigned char *,unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
void    d_sqr(unsigned char *);
void    d_atn(unsigned char *);
int     d_mov(unsigned char *,unsigned char *);

void d_asn(unsigned char *x)
{ unsigned char     a[8],k[8];
  unsigned long     *uk;

    uk = (unsigned long *)k;
#if     FLTMPU
    *uk = 0x3ff00000;               /* k = 1 */
    *(uk+1) = 0;
#else
    *(uk+1) = 0x3ff00000;           /* k = 1 */
    *uk = 0;
#endif
    d_mov(a,x);
    d_mlt(a,x);
    d_sub(k,a);
    d_sqr(k);
    d_div(x,k);
    d_atn(x);
}
