/*  Floating Point(Double) Calc Subroutine
        void d_div(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */

int     _dnorm(unsigned char *);
void    _danorm(unsigned char *,int);
int     _ddivx(unsigned char *,unsigned char *);
void    _ddivz(unsigned char *,unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
int     _zrchkd(unsigned char *);
int     _dnorma(unsigned char *);

void d_div(unsigned char *x,unsigned char *y)
{ int   a,b;
  unsigned char     f[8];

    if (_zrchkd(x) == 1) return;

    d_mov(f,y);
    a = _dnorm(x);
    b = _dnorm(f);
    a = a - b + 0x3ff;
    a += _ddivx(x,f);
    _danorm(x,a);
}


int _ddivx(unsigned char *x,unsigned char *y)
{ int       a;

    _ddivz(x,y);

    a = _dnorma(x);
    return(a);
}

