/*  Floating Point(Double) Calc Subroutine
        void d_mlt(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.4.24   */

int     _dnorm(unsigned char *);
void    _danorm(unsigned char *,int);
int     _dmltx(unsigned char *,unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
int     _zrchkd(unsigned char *);
int     _dnorma(unsigned char *);
void    _dmltz(unsigned char *,unsigned char *);

void d_mlt(unsigned char *x,unsigned char *y)
{ int   a,b;
  unsigned char     f[8];

    if (_zrchkd(x) == 1) return;
    if (_zrchkd(y) == 1) {
        d_mov(x,y);
        return;
    }

    d_mov(f,y);
    a = _dnorm(x);
    b = _dnorm(f);
    a = a + b - 0x3ff;

    a += _dmltx(x,f);
    _danorm(x,a);
}

int _dmltx(unsigned char *x,unsigned char *y)
{ unsigned long     a;

    _dmltz(x,y);

    a = _dnorma(x);
    return(a);
}
