/*  Floating Point(Double) Calc Subroutine
        void d_pow10(unsigned char *x);
            10^x = exp(x*ln(10));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    _ovrfld(unsigned char *,int);
void    _undfld(unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
void    i_tod(unsigned char*,int);
void    rddpow(unsigned char *,int);

void d_pow10(unsigned char *x,int n)
{ unsigned char     a[8];
  int               i,m;

    if (n < -308) _undfld(x);
    else if (n > 308) _ovrfld(x,0);
    else {
        i = 1;
        i_tod(x,i);
        if (n > 0) {
            m = 256;
            i = 9;
            while(1) {
                if (n >= m) {
                    rddpow(a,i);
                    d_mlt(x,a);
                    n -= m;
                }
                m /= 2;
                i--;
                if (i < 0) break;
            }
        }
        else if (n < 0) {
            n = -n;
            m = 256;
            i = 9;
            while(1) {
                if (n >= m) {
                    rddpow(a,i);
                    d_div(x,a);
                    n -= m;
                }
                m /= 2;
                i--;
                if (i < 0) break;
            }
        }
    }
}
