--  Floating Point(Double) Calucuration Program Subroutines
--      Copyright(c) 2007, S.SAKAI  2007.3.29

--      void d_pai(unsigned char *x,int n)
--              n=0:    x[7]..x[0] = pai
--              n=1:    x[7]..x[0] = pai*2
--              n=2:    x[7]..x[0] = pai/2
--              n=3:    x[7]..x[0] = pai*3/2
--              n=4:    x[7]..x[0] = pai/4
--              n=5:    x[7]..x[0] = 180/pai

        .text
        .globl  _d_pai
        .align  4
_d_pai: shl     3,r7
        add     #pd_tbl,r7
        ld.w    [r7],r10
        st.w    r10,[r6]
        ld.w    4[r7],r10
        st.w    r10,4[r6]
        jmp     [lp]

pd_tbl: .word   0x54442d18      -- pai
        .word   0x400921fb
        .word   0x54442d18      -- pai*2
        .word   0x401921fb
        .word   0x54442d18      -- pai/2
        .word   0x3ff921fb
        .word   0x7f3321d2      -- pai*3/2
        .word   0x4012d97c
        .word   0x54442d18      -- pai/4
        .word   0x3fe921fb
        .word   0x1a63c1f8      -- 180/pai
        .word   0x404ca5dc
