--  d_exp() Data Table
--      Copyright(c) 2007, S.SAKAI  2007.3.9
--
--      void rddexp(unsigned char *x,int n);
--          x = exp(2^i)  i=0-9;

    .text
    .globl  _rddexp
    .align  4

_rddexp:
    shl     3,r7
    add     #dexp_tbl,r7
    ld.w    [r7],r10
    st.w    r10,[r6]
    ld.w    4[r7],r10
    st.w    r10,4[r6]
    jmp     [lp]

dexp_tbl:
    .word   0x8B145769    --  0 exp(1)=2.71828
    .word   0x4005BF0A
    .word   0xB8D4DDAE    --  1 exp(2)=7.38906
    .word   0x401D8E64
    .word   0x2E273A58    --  2 exp(4)=54.5982
    .word   0x404B4C90
    .word   0x7D470C6E    --  3 exp(8)=2980.96
    .word   0x40A749EA
    .word   0xD0A80020    --  4 exp(16)=8.88611e+06
    .word   0x4160F2EB
    .word   0xCC4B662C    --  5 exp(32)=7.8963e+13
    .word   0x42D1F43F
    .word   0x2CF597CD    --  6 exp(64)=6.23515e+27
    .word   0x45B42598
    .word   0xC5DD4218    --  7 exp(128)=3.88771e+55
    .word   0x4B795E54
    .word   0x8814BEBA    --  8 exp(256)=1.51143e+111
    .word   0x57041C7A
    .word   0x04BA852E    --  9 exp(512)=2.28441e+222
    .word   0x6E194765
