--  Floating Point(double) Calucuration Program Subroutines
--      Copyright(c) 2007, S.SAKAI  2007.4.12


--      int _dnormb(unsigned char *x)

        .text
        .globl  __dnormb
        .align  4
__dnormb:
        add     -4,r3
        st.w    r11,[r3]

        ld.w    [r6],r8
        ld.w    4[r6],r9
        mov     0,r11
        mov     0,r10
dnormb1:mov     r9,r7
        shr     24,r7
        andi    0xff,r7,r7
        bz      dnormb4
        cmp     1,r7
        bz      dnormb6
        mov     0,r11
        shr     1,r8
        bnc     dnormb2
        mov     1,r11
dnormb2:shr     1,r9
        bnc     dnormb3
        mov     0x80000000,r7
        or      r7,r8
dnormb3:add     1,r10
        jr      dnormb1
dnormb4:mov     0,r11
        shl     1,r9
        shl     1,r8
        bnc     dnormb5
        ori     1,r9,r9
dnormb5:add     -1,r10
        jr      dnormb1

dnormb6:and     r11,r11
        bz      dnormb8
        add     1,r8
        bnc     dnormb8
        add     1,r9
        mov     r9,r7
        shr     28,r7
        and     0xe,r7
        bz      dnormb8
        shr     1,r8
        shr     1,r9
        bnc     dnormb7
        mov     0x80000000,r7
        or      r7,r8
dnormb7:add     1,r10

dnormb8:st.w    r9,4[r6]
        st.w    r8,[r6]

        ld.w    [r3],r11
        add     4,r3
        jmp     [lp]

--      void _dadd1b(unsigned char *x,int z)
--          x[7]..x[0] += z;

    .text
    .globl  __dadd1b
    .align  4
__dadd1b:
    ld.w    [r6],r10
    add     r7,r10
    st.w    r10,[r6]
    bnc     dadd1b1
    ld.w    4[r6],r10
    add     1,r10
    st.w    r10,4[r6]
dadd1b1:
    jmp     [lp]

