--  d_pow10() Data Table
--      Copyright(c) 2007, S.SAKAI  2007.3.9

--      void rddpow(unsigned char *x,int n);
--          x = 1               i = 0
--          x = 10^(2^(i-1))    i > 0

    .text
    .globl  _rddpow
    .align  4

_rddpow:
    shl     3,r7
    add     #dpow_tbl,r7
    ld.w    [r7],r10
    st.w    r10,[r6]
    ld.w    4[r7],r10
    st.w    r10,4[r6]
    jmp     [lp]

dpow_tbl:
    .word   0x00000000    --  0  1.0E+00
    .word   0x3FF00000
    .word   0x00000000    --  1  1.0E+01
    .word   0x40240000
    .word   0x00000000    --  2  1.0E+02
    .word   0x40590000
    .word   0x00000000    --  3  1.0E+04
    .word   0x40C38800
    .word   0x00000000    --  4  1.0E+08
    .word   0x4197D784
    .word   0x37E08000    --  5  1.0E+16
    .word   0x4341C379
    .word   0xB5056E17    --  6  1.0E+32
    .word   0x4693B8B5
    .word   0xE93FF9F6    --  7  1.0E+64
    .word   0x4D384F03
    .word   0xF9301D33    --  8  1.0E+128
    .word   0x5A827748
    .word   0x7F73BF3F    --  9  1.0E+256
    .word   0x75154FDD
