--  fexp() Data Table
--      Copyright(c) 2007, S.SAKAI  2007.3.9
--
--      void rdfexp(unsigned char *x,int n);
--          x = exp(2^i)  i=0-9;

    .text
    .globl  _rdfexp
    .align  4

_rdfexp:
    shl     2,r7
    add     #fexp_tbl,r7
    ld.w    [r7],r10
    st.w    r10,[r6]
    jmp     [lp]

fexp_tbl:
    .word   0x402DF854    --  0 exp(1)=2.71828
    .word   0x40EC7326    --  1 exp(2)=7.38906
    .word   0x425A6481    --  2 exp(4)=54.5981
    .word   0x453A4F54    --  3 exp(8)=2980.96
    .word   0x4B07975F    --  4 exp(16)=8.88611e+06
    .word   0x568FA1FE    --  5 exp(32)=7.8963e+13
    .word   0x6DA12CC1    --  6 exp(64)=6.23515e+27
