/*  RS-232C Program for Floating Point Calculation Library Test Program
        Copyright(c) 2007, S.SAKAI  2007.6.13
*/
/*
*******************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2, V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :  serial.h
**  Abstract :  This file implements a device driver for the SERIAL module
**  APIlib :    V850ESJx2.lib V1.70 [7 Dec. 2006]
**
**  Device :    uPD70F3716
**
**  Compiler :  NEC/CA850
**
*******************************************************************************
*/
#ifndef _MDSERIAL_
#define _MDSERIAL_

#define     UART0_BAUDRATE_M0   0x0
#define     UART0_BAUDRATE_K0   0x57

void UART0_Init( void );
void sci1_putc(unsigned char);
void sci1_puts(unsigned char *,unsigned short);
short sci1_getc(void);

enum TransferMode { Send, Receive };

#endif  /*_MDSERIAL_*/

