/*  Floating Point(Float) Calc Subroutine
        void f_neg(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

/*      x = -x;     */
void f_neg(unsigned char *x)
{ unsigned long     *ux;

    ux = (unsigned long *)x;
    if (*ux) {
#if     FLTMPU
        if (x[0] & 0x80) x[0] &= 0x7f;
        else x[0] |= 0x80;
#else
        if (x[3] & 0x80) x[3] &= 0x7f;
        else x[3] |= 0x80;
#endif
    }
}
