/*  Floating Point(Float) Calc Subroutines
    Data Table fot d_exp,f_exp
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include        <math.h>


float   fextbl[8];
double  dextbl[10];
int     __fexpinit=0;

void exptblinit(void)
{ int       i,j;
  float     eaf;
  double    ead;

    j = 1;                      /* fextable */
    for (i=0;i<=6;i++) {
        fextbl[i] = exp(j);
        j *= 2;
    }

    j = 1;                      /* dextable */
    for(i=0;i<=9;i++) {
        dextbl[i] = exp(j);
        j *= 2;
    }
    __fexpinit = 1;
}

void rdfexp(unsigned char *exc,int n)
{ int       i;
  unsigned char     *uc;

    if (__fexpinit == 0) exptblinit();

    uc = (unsigned char *)&fextbl[n];
    for(i=0;i<4;i++) exc[i] = uc[i];
}

void rddexp(unsigned char *exc,int n)
{ int       i;
  unsigned char     *uc;

    if (__fexpinit == 0) exptblinit();

    uc = (unsigned char *)&dextbl[n];
    for(i=0;i<8;i++) exc[i] = uc[i];
}
