/*  Floating Point(Float) Calc Subroutines
    Data Table fot d_pow10,f_pow10
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include        <math.h>


float   fpwtbl[7];
double  dpwtbl[10];
int     __fpowinit=0;

void powtblinit(void)
{ int       i,j;

    for (i=0;i<=6;i++) {                /* fpwtable */
        if (i == 0) fpwtbl[i] = 1;
        else if (i == 1) fpwtbl[i] = 10;
        else fpwtbl[i] = fpwtbl[i-1] * fpwtbl[i-1];
    }

    for (i=0;i<=9;i++) {                /* fpwtable */
        if (i == 0) dpwtbl[i] = 1;
        else if (i == 1) dpwtbl[i] = 10;
        else dpwtbl[i] = dpwtbl[i-1] * dpwtbl[i-1];
    }
    __fpowinit = 1;
}

void rdfpow(unsigned char *exc,int n)
{ int       i;
  unsigned char     *uc;

    if (__fpowinit == 0) powtblinit();

    uc = (unsigned char *)&fpwtbl[n];
    for(i=0;i<4;i++) exc[i] = uc[i];
}

void rddpow(unsigned char *exc,int n)
{ int       i;
  unsigned char     *uc;

    if (__fpowinit == 0) powtblinit();

    uc = (unsigned char *)&dpwtbl[n];
    for(i=0;i<8;i++) exc[i] = uc[i];
}
