/*  Floating Point(Double) Calc Subroutine
        void d_log(unsigned char *x);
            log(x) = ln(x) / ln(10);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    d_div(unsigned char *,unsigned char *);
void    d_ln(unsigned char *);
int     _zrchkd(unsigned char *);

void d_log(unsigned char *x)
{ unsigned char     a[8];
  int   i,j;
  unsigned long     *ua;

    ua = (unsigned long *)a;

#if     FLTMPU
    if ((x[0] & 0x80) || (_zrchkd(x) == 1)) return;

    *ua = 0x40240000;               /* a = 10 */
    *(ua+1) = 0;
#else
    if ((x[7] & 0x80) || (_zrchkd(x) == 1)) return;

    *(ua+1) = 0x40240000;           /* a = 10 */
    *ua = 0;
#endif
    d_ln(a);
    d_ln(x);
    d_div(x,a);
}
