/*  Floating Point(Double) Calc Subroutine
        void d_sin(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.7    */

int     d_sgn(unsigned char *);
void    d_pai(unsigned char *,int);
int     _dcmpxy(unsigned char *,unsigned char *);
void    d_neg(unsigned char *);
void    d_sub(unsigned char *,unsigned char *);
void    _fndsinx(unsigned char *);
void    _fndcosx(unsigned char *);

void d_sin(unsigned char *x)
{ unsigned char     p[8],p2[8],ph[8],pq[8],p1h[8];
  int   sgn;

    d_pai(p,0);
    d_pai(p2,1);
    d_pai(ph,2);
    d_pai(pq,4);
    d_pai(p1h,3);

    sgn = 0;
    if (d_sgn(x) < 0) {
        sgn = ~sgn;
        d_neg(x);
    }

    while(1) {
        if (_dcmpxy(x,p2) <= 0) break;
        d_sub(x,p2);
    }
    if (_dcmpxy(x,p1h) > 0) {
        sgn = ~sgn;
        d_sub(x,p2);
        d_neg(x);
    }
    else if (_dcmpxy(x,p) > 0) {
        sgn = ~sgn;
        d_sub(x,p);
    }
    else if (_dcmpxy(x,ph) > 0) {
        d_sub(x,p);
        d_neg(x);
    }

    if (_dcmpxy(x,pq) > 0) {
        d_sub(x,ph);
        d_neg(x);
        _fndcosx(x);
    }
    else _fndsinx(x);

    if (sgn) d_neg(x);
}
