/*  Floating Point(Float) Calc Subroutine
        void f_asn(unsigned char *x);
            asin(x) = atan((x/sqr(1-x*x));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    f_sub(unsigned char *,unsigned char *);
void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);
void    f_sqr(unsigned char *);
void    f_atn(unsigned char *);

void f_asn(unsigned char *x)
{ unsigned char     x2[4],a[4],k[4];
  unsigned long     *ux,*ua,*uk;

    ux = (unsigned long *)x;
    ua = (unsigned long *)a;
    uk = (unsigned long *)k;

    *uk = 0x3f800000;               /* k = 1 */
    *ua = *ux;
    f_mlt(a,x);
    f_sub(k,a);
    f_sqr(k);
    f_div(x,k);
    f_atn(x);
}
