/*  Floating Point(Float) Calc Subroutine
        void f_div(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */

int     _fnorm(unsigned char *);
int     _fanorm(unsigned char *,int);
int     _fdivx(unsigned char *,unsigned char *);
int     _fnorma(unsigned char *);
void    _fdivz(unsigned char *,unsigned char *);

void f_div(unsigned char *x,unsigned char *y)
{ int   a,b;
  unsigned char     f[4];
  unsigned long     *ux,*uy,*uf;

    ux = (unsigned long *)x;
    if (*ux == 0) return;

    uy = (unsigned long *)y;
    uf = (unsigned long *)f;

    *uf = *uy;
    a = _fnorm(x);
    b = _fnorm(f);
    a = a - b + 0x7f;

    a += _fdivx(x,f);
    _fanorm(x,a);
}

int _fdivx(unsigned char *x,unsigned char *y)
{ int       i;

    _fdivz(x,y);

    i = _fnorma(x);
    return(i);
}
