/*  Floating Point(Float) Calc Subroutine
        void f_log(unsigned char *x);
            log(x) = ln(x) / ln(10);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    f_div(unsigned char *,unsigned char *);
void    f_ln(unsigned char *);

void f_log(unsigned char *x)
{ unsigned char     a[4];
  unsigned long     *ux,*ua;

    ux = (unsigned long *)x;
    ua = (unsigned long *)a;

#if     FLTMPU
    if ((x[0] & 0x80) || (*ux == 0)) return;
#else
    if ((x[3] & 0x80) || (*ux == 0)) return;
#endif

    *ua = 0x41200000;               /* a = 10 */
    f_ln(a);
    f_ln(x);
    f_div(x,a);
}
