/*  Floating Point(Float) Calc Subroutine
        void f_mlt(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.24   */

int     _fnorm(unsigned char *);
int     _fanorm(unsigned char *,int);
int     _fmltx(unsigned char *,unsigned char *);
int     _fnorma(unsigned char *);
void    _fmltz(unsigned char *,unsigned char *);

void f_mlt(unsigned char *x,unsigned char *y)
{ int   a,b;
  unsigned char     f[4];
  unsigned long     *ux,*uy,*uf;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
    uf = (unsigned long *)f;

    if (*ux == 0) return;
    if (*uy == 0) {
        *ux = *uy;
        return;
    }

    *uf = *uy;
    a = _fnorm(x);
    b = _fnorm(f);
    a = a + b - 0x7f;

    a += _fmltx(x,f);
    _fanorm(x,a);
}

int _fmltx(unsigned char *x,unsigned char *y)
{ unsigned long     a;

    _fmltz(x,y);

    a = _fnorma(x);
    return(a);
}
