/*  Floating Point(Float) Calc Subroutine
        void f_tan(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.7    */

int     f_sgn(unsigned char *);
void    f_sin(unsigned char *);
void    f_cos(unsigned char *);
void    f_div(unsigned char *,unsigned char *);

void f_tan(unsigned char *x)
{ unsigned char     y[4];
  unsigned long     *ux,*uy;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;

    *uy = *ux;
    f_cos(y);
    f_sin(x);
    if (*uy == 0) {
        if (f_sgn(x) >= 0) *ux = 0x7fffff;
        else *ux = 0xffffffff;
        return;
    }
    f_div(x,y);
}
