/*  Floating Point(Double) Calc Subroutine
        void _fndsinx(unsigned char *x); (0 <= x <= pai/4)
        void _fndcosx(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    i_tod(unsigned char *,int);
void    d_mov(unsigned char *,unsigned char *);
void    d_add(unsigned char *,unsigned char *);
void    d_sub(unsigned char *,unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
int     _dcmpxy(unsigned char *,unsigned char *);

void _fndsinx(unsigned char *x)
{ unsigned char     a[8],b[8],x2[8],z[8];
  int   f,i,j;

    f = 0;
    i = 2;
    j = 16;
    i_tod(a,0);

    d_mov(b,x);
    d_mov(x2,x);
    d_mlt(x2,x);

    while(1) {
        if (j-- == 0) break;
        if (_dcmpxy(a,b) == 0) break;
        d_mov(b,a);
        if (f == 0) {
            d_add(a,x);
            f = 1;
        }
        else {
            d_sub(a,x);
            f = 0;
        }
        d_mlt(x,x2);
        i_tod(z,i*(i+1));
        d_div(x,z);
        i += 2;
    }
    d_mov(x,a);
}

void _fndcosx(unsigned char *x)
{ unsigned char     a[8],b[8],x2[8],z[8];
  int   f,i,j;

    f = 0;
    i = 1;
    j = 16;
    i_tod(a,0);
    i_tod(b,1);
    d_mov(x2,x);
    d_mlt(x2,x);
    i_tod(x,1);

    while(1) {
        if (j-- == 0) break;
        if (_dcmpxy(a,b) == 0) break;
        d_mov(b,a);
        if (f == 0) {
            d_add(a,x);
            f = 1;
        }
        else {
            d_sub(a,x);
            f = 0;
        }
        d_mlt(x,x2);
        i_tod(z,i*(i+1));
        d_div(x,z);
        i += 2;
    }
    d_mov(x,a);
}
