/*  Floating Point(Float) Calc Subroutine
        void _fnfsinx(unsigned char *x); (0 <= x <= pai/4)
        void _fnfcosx(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    i_tof(unsigned char *,int);
void    f_add(unsigned char *,unsigned char *);
void    f_sub(unsigned char *,unsigned char *);
void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);

void _fnfsinx(unsigned char *x)
{ unsigned char     a[4],b[4],x2[4],z[4];
  int   f,i,j;
  unsigned long     *ux,*ua,*ub,*ux2;

    ux = (unsigned long *)x;
    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    ux2 = (unsigned long *)x2;

    f = 0;
    i = 2;
    j = 16;
    i_tof(a,0);

    *ub = *ux;
    *ux2 = *ux;
    f_mlt(x2,x);

    while(1) {
        if (j-- == 0) break;
        if (*ua == *ub) break;

        *ub = *ua;
        if (f == 0) {
            f_add(a,x);
            f = 1;
        }
        else {
            f_sub(a,x);
            f = 0;
        }
        f_mlt(x,x2);
        i_tof(z,i*(i+1));
        f_div(x,z);
        i += 2;
    }
    *ux = *ua;
}

void _fnfcosx(unsigned char *x)
{ unsigned char     a[4],b[4],x2[4],z[4];
  int   f,i,j;
  unsigned long     *ux,*ux2,*ua,*ub;

    ux = (unsigned long *)x;
    ux2 = (unsigned long *)x2;
    ua = (unsigned long *)a;
    ub = (unsigned long *)b;

    f = 0;
    i = 1;
    j = 16;
    i_tof(a,0);
    i_tof(b,1);
    *ux2 = *ux;
    f_mlt(x2,x);
    i_tof(x,1);

    while(1) {
        if (j-- == 0) break;
        if (*ua == *ub) break;
        *ub = *ua;
        if (f == 0) {
            f_add(a,x);
            f = 1;
        }
        else {
            f_sub(a,x);
            f = 0;
        }
        f_mlt(x,x2);
        i_tof(z,i*(i+1));
        f_div(x,z);
        i += 2;
    }
    *ux = *ua;
}
