--  Floating Point(Float) Calucuration Program Subroutines
--      Copyright(c) 2007, S.SAKAI  2007.3.29

--      void f_pai(unsigned char *x,int n)
--              n=0:    x[3]..x[0] = pai
--              n=1:    x[3]..x[0] = pai*2
--              n=2:    x[3]..x[0] = pai/2
--              n=3:    x[3]..x[0] = pai*3/2
--              n=4:    x[3]..x[0] = pai/4
--              n=5:    x[3]..x[0] = 180/pai

        .text
        .globl  _f_pai
        .align  4

_f_pai: shl     2,r7
        add     #pf_tbl,r7
        ld.w    [r7],r10
        st.w    r10,[r6]
        jmp     [lp]

pf_tbl: .word   0x40490fdb      -- pai
        .word   0x40c90fdb      -- pai*2
        .word   0x3fc90fdb      -- pai/2
        .word   0x4096cbe4      -- pai*3/2
        .word   0x3f490fdb      -- pai/4
        .word   0x42652ee0      -- 180/pai
