--  Floating Point(float) Calucuration Program Subroutines
--      Copyright(c) 2007, S.SAKAI  2007.4.12

--      int _fnorm(unsigned char *x)
--          r:x[3]x[2] >> 7;
--          (x[3]x[2] & 0x7f) | 0x80;    x[3]..x[0] <<= 5;

        .text
        .globl  __fnorm
        .align  4
__fnorm:
        ld.w    [r6],r10
        mov     r10,r7
        shr     23,r10
        mov     0x7fffff,r8
        and     r8,r7
        mov     0x800000,r8
        or      r8,r7
        shl     5,r7
        st.w    r7,[r6]
        jmp     [lp]

--      void _fanorm(unsigned char *x,int a)
--          x[3]..x[0] >>= 5;
--          (x[3]x[2] & 0x7f) |= (a << 7)

        .text
        .globl  __fanorm
        .align  4
__fanorm:
        ld.w    [r6],r10
        mov     0x20000000,r8
        and     r10,r8
        bz      fanorm1
        add     1,r7
        add     0x20,r10
        mov     6,r8
        jr      fanorm2
fanorm1:
        add     0x10,r10
        mov     5,r8
fanorm2:
        shr     r8,r10
        mov     0xff000000,r8
        and     r10,r8
        bz      fanorm3
        shr     1,r10
        add     1,r7
fanorm3:
        mov     0x7fffff,r8
        and     r8,r10
        shl     23,r7
        or      r7,r10
        st.w    r10,[r6]
        jmp     [lp]

