--  f_pow10() Data Table
--      Copyright(c) 2007, S.SAKAI  2007.3.9

--      void rdfpow(unsigned char *x,int n);
--          x = 1               i = 0
--          x = 10^(2^(i-1))    i > 0

    .text
    .globl  _rdfpow
    .align  4

_rdfpow:
    shl     2,r7
    add     #fpow_tbl,r7
    ld.w    [r7],r10
    st.w    r10,[r6]
    jmp     [lp]

fpow_tbl:
    .word   0x3F800000    --  0  1.0E+00
    .word   0x41200000    --  1  1.0E+01
    .word   0x42C80000    --  2  1.0E+02
    .word   0x461C4000    --  3  1.0E+04
    .word   0x4CBEBC20    --  4  1.0E+08
    .word   0x5A0E1BCA    --  5  1.0E+16
    .word   0x749DC5AE    --  6  1.0E+32
