/*      Int Vector Table for SH7144
    Copyright(c) 2007, S.SAKAI  2007.6.13       */


extern int      main(void);
extern void     dummy(void);

extern void     int_cmi0(void);

extern void     int_eri1(void);
extern void     int_rxi1(void);
extern void     int_txi1(void);
extern void     int_tei1(void);


#pragma section VECTTBL
void *RESET_Vectors[] = {
  main,__secend("S"),       // 0 Power On Reset PC,SP
  main,__secend("S")        // 2 Manual Reset PC,SP
};

#pragma section INTTBL
void *INT_Vectors[] = {
    (void*) dummy,          // 4 Illegal code
    (void*) dummy,          // 5 Reserved
    (void*) dummy,          // 6 Illegal slot
    (void*) dummy,          // 7 Reserved
    (void*) dummy,          // 8 Reserved
    (void*) dummy,          // 9 CPU Address error
    (void*) dummy,          // 10 DTC Address error
    (void*) dummy,          // 11 NMI
    (void*) dummy,          // 12 User breakpoint trap
    (void*) dummy,          // 13 Reserved
    (void*) dummy,          // 14 H-UDI
    (void*) dummy,          // 15 Reserved

    (void*) dummy,          // 16 Reserved
    (void*) dummy,          // 17 Reserved
    (void*) dummy,          // 18 Reserved
    (void*) dummy,          // 19 Reserved
    (void*) dummy,          // 20 Reserved
    (void*) dummy,          // 21 Reserved
    (void*) dummy,          // 22 Reserved
    (void*) dummy,          // 23 Reserved
    (void*) dummy,          // 24 Reserved
    (void*) dummy,          // 25 Reserved
    (void*) dummy,          // 26 Reserved
    (void*) dummy,          // 27 Reserved
    (void*) dummy,          // 28 Reserved
    (void*) dummy,          // 29 Reserved
    (void*) dummy,          // 30 Reserved
    (void*) dummy,          // 31 Reserved

    (void*) dummy,          // 32 TRAPA (User Vecter)
    (void*) dummy,          // 33 TRAPA (User Vecter)
    (void*) dummy,          // 34 TRAPA (User Vecter)
    (void*) dummy,          // 35 TRAPA (User Vecter)
    (void*) dummy,          // 36 TRAPA (User Vecter)
    (void*) dummy,          // 37 TRAPA (User Vecter)
    (void*) dummy,          // 38 TRAPA (User Vecter)
    (void*) dummy,          // 39 TRAPA (User Vecter)
    (void*) dummy,          // 40 TRAPA (User Vecter)
    (void*) dummy,          // 41 TRAPA (User Vecter)
    (void*) dummy,          // 42 TRAPA (User Vecter)
    (void*) dummy,          // 43 TRAPA (User Vecter)
    (void*) dummy,          // 44 TRAPA (User Vecter)
    (void*) dummy,          // 45 TRAPA (User Vecter)
    (void*) dummy,          // 46 TRAPA (User Vecter)
    (void*) dummy,          // 47 TRAPA (User Vecter)

    (void*) dummy,          // 48 TRAPA (User Vecter)
    (void*) dummy,          // 49 TRAPA (User Vecter)
    (void*) dummy,          // 50 TRAPA (User Vecter)
    (void*) dummy,          // 51 TRAPA (User Vecter)
    (void*) dummy,          // 52 TRAPA (User Vecter)
    (void*) dummy,          // 53 TRAPA (User Vecter)
    (void*) dummy,          // 54 TRAPA (User Vecter)
    (void*) dummy,          // 55 TRAPA (User Vecter)
    (void*) dummy,          // 56 TRAPA (User Vecter)
    (void*) dummy,          // 57 TRAPA (User Vecter)
    (void*) dummy,          // 58 TRAPA (User Vecter)
    (void*) dummy,          // 59 TRAPA (User Vecter)
    (void*) dummy,          // 60 TRAPA (User Vecter)
    (void*) dummy,          // 61 TRAPA (User Vecter)
    (void*) dummy,          // 62 TRAPA (User Vecter)
    (void*) dummy,          // 63 TRAPA (User Vecter)

    (void*) dummy,          // 64 Interrupt IRQ0
    (void*) dummy,          // 65 Interrupt IRQ1
    (void*) dummy,          // 66 Interrupt IRQ2
    (void*) dummy,          // 67 Interrupt IRQ3
    (void*) dummy,          // 68 Interrupt IRQ4
    (void*) dummy,          // 69 Interrupt IRQ5
    (void*) dummy,          // 70 Interrupt IRQ6
    (void*) dummy,          // 71 Interrupt IRQ7
    (void*) dummy,          // 72 DMAC DEI0
    (void*) dummy,          // 73 Reserved
    (void*) dummy,          // 74 Reserved
    (void*) dummy,          // 75 Reserved
    (void*) dummy,          // 76 DMAC DEI1
    (void*) dummy,          // 77 Reserved
    (void*) dummy,          // 78 Reserved
    (void*) dummy,          // 79 Reserved

    (void*) dummy,          // 80 DMAC DEI2
    (void*) dummy,          // 81 Reserved
    (void*) dummy,          // 82 Reserved
    (void*) dummy,          // 83 Reserved
    (void*) dummy,          // 84 DMAC DEI3
    (void*) dummy,          // 85 ReservedB
    (void*) dummy,          // 86 Reserved
    (void*) dummy,          // 87 Reserved
    (void*) dummy,          // 88 MTU0 TGIA0
    (void*) dummy,          // 89 MTU0 TGIB0
    (void*) dummy,          // 90 MTU0 TGIC0
    (void*) dummy,          // 91 MTU0 TGID0
    (void*) dummy,          // 92 MTU0 TCIV0
    (void*) dummy,          // 93 Reserved
    (void*) dummy,          // 94 Reserved
    (void*) dummy,          // 95 Reserved

    (void*) dummy,          // 96 MTU1 TGIA1
    (void*) dummy,          // 97 MTU1 TGIB1
    (void*) dummy,          // 98 Reserved
    (void*) dummy,          // 99 Reserved
    (void*) dummy,          // 100 MTU1 TCIV1
    (void*) dummy,          // 101 MTU1 TCIU1
    (void*) dummy,          // 102 Reserved
    (void*) dummy,          // 103 Reserved
    (void*) dummy,          // 104 MTU2 TGIA2
    (void*) dummy,          // 105 MTU2 TGIB2
    (void*) dummy,          // 106 Reserved
    (void*) dummy,          // 107 Reserved
    (void*) dummy,          // 108 MTU2 TCIV2
    (void*) dummy,          // 109 MTU2 TCIU2
    (void*) dummy,          // 110 Reserved
    (void*) dummy,          // 111 Reserved

    (void*) dummy,          // 112 MTU3 TGIA3
    (void*) dummy,          // 113 MTU3 TGIB3
    (void*) dummy,          // 114 MTU3 TGIC3
    (void*) dummy,          // 115 MTU3 TGID3
    (void*) dummy,          // 116 MTU3 TCIV3
    (void*) dummy,          // 117 Reserved
    (void*) dummy,          // 118 Reserved
    (void*) dummy,          // 119 Reserved
    (void*) dummy,          // 120 MTU4 TGIA4
    (void*) dummy,          // 121 MTU4 TGIB4
    (void*) dummy,          // 122 MTU4 TGIC4
    (void*) dummy,          // 123 MTU4 TGID4
    (void*) dummy,          // 124 MTU4 TCIV4
    (void*) dummy,          // 125 Reserved
    (void*) dummy,          // 126 Reserved
    (void*) dummy,          // 127 Reserved

    (void*) dummy,          // 128 SCI0 ERI0
    (void*) dummy,          // 129 SCI0 RXI0
    (void*) dummy,          // 130 SCI0 TXI0
    (void*) dummy,          // 131 SCI0 TEI0
    (void*) int_eri1,       // 132 SCI1 ERI1
    (void*) int_rxi1,       // 133 SCI1 RXI1
    (void*) int_txi1,       // 134 SCI1 TXI1
    (void*) int_tei1,       // 135 SCI1 TEI1
    (void*) dummy,          // 136 A/D ADI0
    (void*) dummy,          // 137 A/D ADI1
    (void*) dummy,          // 138 Reserved
    (void*) dummy,          // 139 Reserved
    (void*) dummy,          // 140 DTC SWDTEND
    (void*) dummy,          // 141 Reserved
    (void*) dummy,          // 142 Reserved
    (void*) dummy,          // 143 Reserved

    (void*) int_cmi0,       // 144 CMT CMT0
    (void*) dummy,          // 145 Reserved
    (void*) dummy,          // 146 Reserved
    (void*) dummy,          // 147 Reserved
    (void*) dummy,          // 148 CMT CMT1
    (void*) dummy,          // 149 Reserved
    (void*) dummy,          // 150 Reserved
    (void*) dummy,          // 151 Reserved
    (void*) dummy,          // 152 WDT ITI
    (void*) dummy,          // 153 BSC CMI
    (void*) dummy,          // 154 Reserved
    (void*) dummy,          // 155 Reserved
    (void*) dummy,          // 156 I/O MTUOEI
    (void*) dummy,          // 157 Reserved
    (void*) dummy,          // 158 Reserved
    (void*) dummy,          // 159 Reserved

    (void*) dummy,          // 160 Reserved
    (void*) dummy,          // 161 Reserved
    (void*) dummy,          // 162 Reserved
    (void*) dummy,          // 163 Reserved
    (void*) dummy,          // 164 Reserved
    (void*) dummy,          // 165 Reserved
    (void*) dummy,          // 166 Reserved
    (void*) dummy,          // 167 Reserved
    (void*) dummy,          // 168 SCI2 ERI2
    (void*) dummy,          // 169 SCI2 RXI2
    (void*) dummy,          // 170 SCI2 TXI2
    (void*) dummy,          // 171 SCI2 TEI2
    (void*) dummy,          // 172 SCI3 ERI3
    (void*) dummy,          // 173 SCI3 RXI3
    (void*) dummy,          // 174 SCI3 TXI3
    (void*) dummy,          // 175 SCI3 TEI3

    (void*) dummy,          // 176 Reserved
    (void*) dummy,          // 177 Reserved
    (void*) dummy,          // 178 Reserved
    (void*) dummy,          // 179 Reserved
    (void*) dummy,          // 180 Reserved
    (void*) dummy,          // 181 Reserved
    (void*) dummy,          // 182 Reserved
    (void*) dummy,          // 183 Reserved
    (void*) dummy,          // 184 Reserved
    (void*) dummy,          // 185 Reserved
    (void*) dummy,          // 186 Reserved
    (void*) dummy,          // 187 Reserved
    (void*) dummy,          // 188 Reserved
    (void*) dummy,          // 189 Reserved
    (void*) dummy,          // 190 Reserved
    (void*) dummy,          // 191 Reserved

    (void*) dummy,          // 192 IIC IIC0RM
    (void*) dummy,          // 193 Reserved
    (void*) dummy,          // 194 Reserved
    (void*) dummy,          // 195 Reserved
    (void*) dummy,          // 196 Reserved
    (void*) dummy,          // 197 Reserved
    (void*) dummy,          // 198 Reserved
    (void*) dummy,          // 199 Reserved
    (void*) dummy,          // 200 I/O MMTOEI
    (void*) dummy,          // 201 Reserved
    (void*) dummy,          // 202 Reserved
    (void*) dummy,          // 203 Reserved
    (void*) dummy,          // 204 Reserved
    (void*) dummy,          // 205 Reserved
    (void*) dummy,          // 206 Reserved
    (void*) dummy,          // 207 Reserved

    (void*) dummy,          // 208 Reserved
    (void*) dummy,          // 209 Reserved
    (void*) dummy,          // 210 Reserved
    (void*) dummy,          // 211 Reserved
    (void*) dummy,          // 212 Reserved
    (void*) dummy,          // 213 Reserved
    (void*) dummy,          // 214 Reserved
    (void*) dummy,          // 215 Reserved
    (void*) dummy,          // 216 Reserved
    (void*) dummy,          // 217 Reserved
    (void*) dummy,          // 218 Reserved
    (void*) dummy,          // 219 Reserved
    (void*) dummy,          // 220 Reserved
    (void*) dummy,          // 221 Reserved
    (void*) dummy,          // 222 Reserved
    (void*) dummy,          // 223 Reserved

    (void*) dummy,          // 224 Reserved
    (void*) dummy,          // 225 Reserved
    (void*) dummy,          // 226 Reserved
    (void*) dummy,          // 227 Reserved
    (void*) dummy,          // 228 Reserved
    (void*) dummy,          // 229 Reserved
    (void*) dummy,          // 230 Reserved
    (void*) dummy,          // 231 Reserved
    (void*) dummy,          // 232 Reserved
    (void*) dummy,          // 233 Reserved
    (void*) dummy,          // 234 Reserved
    (void*) dummy,          // 235 Reserved
    (void*) dummy,          // 236 Reserved
    (void*) dummy,          // 237 Reserved
    (void*) dummy,          // 238 Reserved
    (void*) dummy,          // 239 Reserved

    (void*) dummy,          // 240 Reserved
    (void*) dummy,          // 241 Reserved
    (void*) dummy,          // 242 Reserved
    (void*) dummy,          // 243 Reserved
    (void*) dummy,          // 244 Reserved
    (void*) dummy,          // 245 Reserved
    (void*) dummy,          // 246 Reserved
    (void*) dummy,          // 247 Reserved
    (void*) dummy,          // 248 Reserved
    (void*) dummy,          // 249 Reserved
    (void*) dummy,          // 250 Reserved
    (void*) dummy,          // 251 Reserved
    (void*) dummy,          // 252 Reserved
    (void*) dummy,          // 253 Reserved
    (void*) dummy,          // 254 Reserved
    (void*) dummy           // 255 Reserved

};
